<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUnavailableProduct ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUnavailableProduct
 * @subpackage Arrays
 */
class ArrayOfUnavailableProduct extends AbstractStructArrayBase
{
    /**
     * The UnavailableProduct
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UnavailableProduct[]
     */
    public $UnavailableProduct;
    /**
     * Constructor method for ArrayOfUnavailableProduct
     * @uses ArrayOfUnavailableProduct::setUnavailableProduct()
     * @param \StructType\UnavailableProduct[] $unavailableProduct
     */
    public function __construct(array $unavailableProduct = array())
    {
        $this
            ->setUnavailableProduct($unavailableProduct);
    }
    /**
     * Get UnavailableProduct value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UnavailableProduct[]|null
     */
    public function getUnavailableProduct()
    {
        return isset($this->UnavailableProduct) ? $this->UnavailableProduct : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUnavailableProduct method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUnavailableProduct method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUnavailableProductForArrayConstraintsFromSetUnavailableProduct(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUnavailableProductUnavailableProductItem) {
            // validation for constraint: itemType
            if (!$arrayOfUnavailableProductUnavailableProductItem instanceof \StructType\UnavailableProduct) {
                $invalidValues[] = is_object($arrayOfUnavailableProductUnavailableProductItem) ? get_class($arrayOfUnavailableProductUnavailableProductItem) : sprintf('%s(%s)', gettype($arrayOfUnavailableProductUnavailableProductItem), var_export($arrayOfUnavailableProductUnavailableProductItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UnavailableProduct property can only contain items of type \StructType\UnavailableProduct, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UnavailableProduct value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UnavailableProduct[] $unavailableProduct
     * @return \ArrayType\ArrayOfUnavailableProduct
     */
    public function setUnavailableProduct(array $unavailableProduct = array())
    {
        // validation for constraint: array
        if ('' !== ($unavailableProductArrayErrorMessage = self::validateUnavailableProductForArrayConstraintsFromSetUnavailableProduct($unavailableProduct))) {
            throw new \InvalidArgumentException($unavailableProductArrayErrorMessage, __LINE__);
        }
        if (is_null($unavailableProduct) || (is_array($unavailableProduct) && empty($unavailableProduct))) {
            unset($this->UnavailableProduct);
        } else {
            $this->UnavailableProduct = $unavailableProduct;
        }
        return $this;
    }
    /**
     * Add item to UnavailableProduct value
     * @throws \InvalidArgumentException
     * @param \StructType\UnavailableProduct $item
     * @return \ArrayType\ArrayOfUnavailableProduct
     */
    public function addToUnavailableProduct(\StructType\UnavailableProduct $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UnavailableProduct) {
            throw new \InvalidArgumentException(sprintf('The UnavailableProduct property can only contain items of type \StructType\UnavailableProduct, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UnavailableProduct[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UnavailableProduct|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UnavailableProduct|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UnavailableProduct|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UnavailableProduct|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UnavailableProduct|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UnavailableProduct
     */
    public function getAttributeName()
    {
        return 'UnavailableProduct';
    }
}
