<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecifiedPeriod StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SpecifiedPeriod
 * @subpackage Structs
 */
class SpecifiedPeriod extends AbstractStructBase
{
    /**
     * The AsMonths
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $AsMonths;
    /**
     * The AsYears
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $AsYears;
    /**
     * Constructor method for SpecifiedPeriod
     * @uses SpecifiedPeriod::setAsMonths()
     * @uses SpecifiedPeriod::setAsYears()
     * @param int $asMonths
     * @param int $asYears
     */
    public function __construct($asMonths = null, $asYears = null)
    {
        $this
            ->setAsMonths($asMonths)
            ->setAsYears($asYears);
    }
    /**
     * Get AsMonths value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAsMonths()
    {
        return isset($this->AsMonths) ? $this->AsMonths : null;
    }
    /**
     * Set AsMonths value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $asMonths
     * @return \StructType\SpecifiedPeriod
     */
    public function setAsMonths($asMonths = null)
    {
        // validation for constraint: int
        if (!is_null($asMonths) && !(is_int($asMonths) || ctype_digit($asMonths))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($asMonths, true), gettype($asMonths)), __LINE__);
        }
        if (is_null($asMonths) || (is_array($asMonths) && empty($asMonths))) {
            unset($this->AsMonths);
        } else {
            $this->AsMonths = $asMonths;
        }
        return $this;
    }
    /**
     * Get AsYears value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAsYears()
    {
        return isset($this->AsYears) ? $this->AsYears : null;
    }
    /**
     * Set AsYears value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $asYears
     * @return \StructType\SpecifiedPeriod
     */
    public function setAsYears($asYears = null)
    {
        // validation for constraint: int
        if (!is_null($asYears) && !(is_int($asYears) || ctype_digit($asYears))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($asYears, true), gettype($asYears)), __LINE__);
        }
        if (is_null($asYears) || (is_array($asYears) && empty($asYears))) {
            unset($this->AsYears);
        } else {
            $this->AsYears = $asYears;
        }
        return $this;
    }
}
